class Quiz:
    questionsCounter = 0
    rightAnswers = 0
    wrongAnswers = 0

    def __init__(self, theme, chapter):
        print('Добро пожаловать в тест по теме "%s" из раздела "%s"!' % (theme, chapter))
        print()

    def askQuizQuestion(self, question, options, rightAnswer):
        self.questionsCounter += 1

        print("Вопрос %i: %s" % (self.questionsCounter, question))
        print("Варианты ответов:")
        for i in range(1, len(options)):
            print("%i) %s" % (i, options[i]))

        while True:
            try:
                answer = int(input("Ответ: "))
            except ValueError:
                print("Введите номер ответа!")
                continue
            break

        if answer == rightAnswer:
            print("Верно!")
            self.rightAnswers += 1
        else:
            print("Вы ошиблись.")
            self.wrongAnswers += 1

        print()

    def askTextQuestion(self, question, rightAnswer):
        self.questionsCounter += 1

        print("Вопрос %i: %s" % (self.questionsCounter, question))
        answer = input("Ответ: ")

        if answer == rightAnswer:
            print("Верно!")
            self.rightAnswers += 1
        else:
            print("Вы ошиблись.")
            self.wrongAnswers += 1

        print()

    def finish(self):
        if self.questionsCounter == 0:
            print("Сначала нужно задать вопросы!")
            return

        rightToTotalRatio = round(self.rightAnswers / self.questionsCounter * 100)

        print("Поздравляю с завершением теста!")
        print("Общее количество вопросов: %i." % self.questionsCounter)
        print("Вы ответили верно на %i." % self.rightAnswers)
        print("Неверно на %i." % self.wrongAnswers)
        print("Процент правильных ответов: %i%%." % rightToTotalRatio)
        print("Оценка: «", end='')

        if rightToTotalRatio >= 90:
            print("5", end='')
        elif rightToTotalRatio >= 75:
            print("4", end='')
        elif rightToTotalRatio >= 60:
            print("3", end='')
        elif rightToTotalRatio >= 40:
            print("2", end='')
        else:
            print("1", end='')

        print("».")

        self.questionsCounter = 0
        self.rightAnswers = 0
        self.wrongAnswers = 0
