# encoding: utf-8

class Quiz
    def initialize theme, chapter
        @questionsCounter = 0
        @rightAnswers = 0
        @wrongAnswers = 0

        puts "Добро пожаловать в тест по теме \"#{theme}\" из раздела \"#{chapter}\"!"
        puts
    end

    def askQuizQuestion question, options, rightAnswer
        @questionsCounter += 1

        puts "Вопрос #{@questionsCounter}: #{question}"
        puts "Варианты ответов:"

        for i in 1..options.size
            puts "#{i}) #{options[i-1]}"
        end

        print "Ответ: "
        answer = gets.to_i

        if answer == rightAnswer
            puts "Верно!"
            @rightAnswers += 1
        else
            puts "Вы ошиблись."
            @wrongAnswers += 1
        end

        puts
    end

    def askTextQuestion question, rightAnswer
        @questionsCounter += 1

        puts "Вопрос #{@questionsCounter}: #{question}"
        print "Ответ: "
        answer = gets.chomp

        if answer == rightAnswer
            puts "Верно!"
            @rightAnswers += 1
        else
            puts "Вы ошиблись."
            @wrongAnswers += 1
        end

        puts
    end

    def finish
        if @questionsCounter == 0
            puts "Сначала нужно задать вопросы!"
            return
        end

        rightToTotalRatio = (@rightAnswers.to_f / @questionsCounter.to_f * 100).round

        puts "Поздравляю с завершением теста!"
        puts "Общее количество вопросов: #{@questionsCounter}."
        puts "Вы ответили верно на #{@rightAnswers}."
        puts "Неверно на #{@wrongAnswers}."
        print "Процент правильных ответов: ", rightToTotalRatio, "%.\n"
        print "Оценка: «"

        if rightToTotalRatio >= 90
            print "5"
        elsif rightToTotalRatio >= 75
            print "4"
        elsif rightToTotalRatio >= 60
            print "3"
        elsif rightToTotalRatio >= 40
            print "2"
        else
            print "1"
        end

        puts "»."

        @questionsCounter = 0
        @rightAnswers = 0
        @wrongAnswers = 0
    end
end
